<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml"> 
<?php
//    Copyright 2010 Andrii Salnikov
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//				   
// -------- Setting up global parameters ----------------------------------------------------------------
ini_set("include_path", "./interfaces:./modules:./lang:./content:./conf");
ini_set("session.name", "_a_md5");
error_reporting(E_ALL); ini_set("display_errors", 1);
require("config.inc");
$pva_version = "0.6";
// Regular expressions for syntax checking
require("regex.php");
// Lang selection
require("langdetect.php");
// Get VO configuration to work with
require("get_vo_configuration.php");
// Load functions
require_once("operations.php");

// ---------  Configuration defaults -----------------------------------------------------------------------
if ( ! isset($items_per_page) ) if ( isset($members_per_page) ) $items_per_page = $members_per_page; // PVA<0.6 compatibility
else $items_per_page = 10;
if ( ! isset($ca_certificates_path) )  $ca_certificates_path   = "/etc/grid-security/certificates";
if ( ! isset($lastresort_permissions)) $lastresort_permissions = 517;
// ---------  Passed parameters ----------------------------------------------------------------------------
// GET
$action = ( isset($_GET["action"]) ) ? $_GET["action"] : "manage";
$operation = ( isset($_GET["operation"]) ) ? $_GET["operation"] : "list";

$limit = ( isset($_GET["limit"]) ) ? $_GET["limit"] : 0;
$uid = ( isset($_GET["id"]) ) ? $_GET["id"] : 0;

// POST
$filter = ( isset($_POST["search"]) ) ? $_POST["search"] : null;
if ( $filter === null ) $filter = ( isset($_GET["search"]) ) ? $_GET["search"] : null;

// --------- x509 client certificate authorization ----------------------------------------------------------
require("https_client_auth.php");
// --------- HTML header ------------------------------------------------------------------------------------
require("html_header.php");
// -------- Draw global header ------------------------------------------------------------------------------
require("interface_header.php");
// -------- Show menu bar -----------------------------------------------------------------------------------
require("interface_menu_bar.php");
// -------- Main container block to proceed with content ----------------------------------------------------
echo "<div id=\"maincontainer\">\n";
	// Check user input section ( if some of parameters passed to script is not correct prevent execution with error )
	if ( ! preg_match($regex_digits, $limit) ) hackexit();
	if ( ! preg_match($regex_digits, $uid) ) hackexit();
	echo "<div id=\"content\">\n";
		// ------------- Title page ( no VO passed to script ) ---------------------
		if ( $vo === 0 ) {
			$globop = (isset($_GET["globop"]))?$_GET["globop"]:"listvos";
			// Global operations handling
			if ( $globop == "mailadm" ) {
				require("globop_mailadm.php");
			} else if ( $globop == "newvo" ) {
				require("globop_newvo.php");
			} else {
				// default operation -- list VOs avaliable on the server
				require("globop_listvos.php");
			}
		// ------------- VO passed to script and served by server ------------------
		} else if ( $isfailed === 0 ) {
			// ###action: manage --- default action 
			if ( $action === "manage" ) {
				// Left manage menu allways present
				require("vo_action_manage_menu.php");
				// workarea is container to direct information specified by $operation
				echo "<div id=\"workarea\">\n";
				// check for POST operations and proceed
				require("vo_action_manage_post.php");
				// Delete user is requested
				if ( $operation === "delete" ) {
					if ( isACLallow($pvap,"membership","w") ) {
						// Delete user then return to listing
						if ( ! _invoke_transactional_sql(1,'deleteUser',$uid) ) 
							printf("<p class=\"error\">%s</p>",$voms_delete_failed);
						$operation = "list";
					} else hackexit(1);
				}
				// Delete group is requested 
				if ( $operation === "deletegrp" ) {
					if ( isACLallow($pvap,"container","w") ) {
						// Delete group then return to listing groups
						$dgres = _invoke_transactional_sql(1,'deleteGroup',$uid, $vo);
						if ( $dgres === -1 ) printf("<p class=\"error\">%s</p>",$voms_deletegrp_cannot); else
						if ( $dgres === 0 ) printf("<p class=\"error\">%s</p>",$voms_deletegrp_failed);
						$operation = "groupslist";
					} else hackexit(1);
				}
				// Delete role is requested
				if ( $operation === "deleterole" ) {
					if ( isACLallow($pvap,"container","w") ) {
						// Delete role then return to listing roles
						$dgres = _invoke_transactional_sql(1,'deleteRole',$uid, $vo);
						if ( $dgres === 0 ) printf("<p class=\"error\">%s</p>",$voms_deleterole_failed);
						$operation = "roleslist";
					} else hackexit(1);
				}
				// Event log notify
				if ( $operation === "list" ) if ( isACLallow($pvap,"preferences","w") ) 
					require("interface_event_log_notify.php");
				// #operation: leave VO membership
				if ( $operation === "leavevo" ) {
					if ( $member ) {
						if ( _invoke_transactional_sql(1,'deleteUser',$member) ) 
							printf("<p class=\"alldone\">%s</p>",$voms_leavevo_ok);
						else printf("<p class=\"error\">%s</p>",$voms_delete_failed);
					}
					$operation = "list";
				}
				// #operation list VO members -- default operation
				if ( $operation === "list" ) {
					if ( isACLallow($pvap,"membership","r") ) 
						showUsermanagement ( $vo, $limit, $filter, isACLallow($pvap,"membership","w"), $member);
				// #operation list VO Groups
				} else if ( $operation === "groupslist" ) {
					if ( isACLallow($pvap,"container","r") ) 
						showGroupmanagement ( $vo, $limit, $filter, isACLallow($pvap,"container","w") );
				// #operation list VO Roles
				} else if ( $operation === "roleslist" ) {
					if ( isACLallow($pvap,"container","r") ) 
						showRolesmanagement ( $vo, $limit, $filter, isACLallow($pvap,"container","w") );
				// #operation list VO Users Attributes
				} else if ( $operation === "attrlist" ) {
					if ( isACLallow($pvap,"attributes","r") ) 
						showAttrsmanagement ( $vo, $limit, $filter, isACLallow($pvap,"attributes","w") );
				// #operation: create new VO member
				} else if ( $operation === "create" ) { 
					require("vo_action_manage_op_create.php");
				// #operation: create new group
				} else if ( $operation === "creategrp" ) {
					require("vo_action_manage_op_creategrp.php");
				// #operation: create new role
				} else if ( $operation === "createrole" ) {
					require("vo_action_manage_op_createrole.php");
				// #operation: manage attribute classes
				} else if ( $operation === "mattr" ) {
					require("vo_action_manage_op_mattr.php");
				// #operation: show information about user
				} else if ( $operation === "userinfo" ) {
					require("vo_action_manage_op_userinfo.php");
				// #operation: show information about group
				} else if ( $operation === "groupinfo" ) { 
					require("vo_action_manage_op_groupinfo.php");
				// #operation: show information about role
				} else if ( $operation === "roleinfo" ) {
					require("vo_action_manage_op_roleinfo.php");
				// #operation: add ACL entry
				} else if ( $operation === "aclnew" ) {
					echo "<div id=\"workareaf\">\n";
					$default = ( isset($_GET["def"]) ) ? $_GET["def"] : 0;
					$acldeff = ($default) ? "d" : "w";
					if ( $uid != 1 ) {
						$g_perm = getProperUserACL($USER_DN, $USER_CA, $member, $uid);
						if ( $g_perm !== 0 ) $pvap = decodeACLPermissions($g_perm);
					}
					if ( isACLallow($pvap,"acl",$acldeff)) {
						showNewACLForm($vo, $uid, $default);
					}
					echo "</div>";
				// #operation: edit ACL entry
				} else if ( $operation === "acledit" ) {
					echo "<div id=\"workareaf\">";
					$admid = ( isset($_GET["adm"])) ? $_GET["adm"] : 0;
					if ( editACLmanagement ( $vo, $uid, $admid, $pvap, $USER_DN, $USER_CA, $member) == -1 )
						hackexit(1);
					echo "</div>";
				// #operation: delete ACL entry
				} else if ( $operation === "acldel" ) {
					echo "<div id=\"workareaf\">";
					$admid = ( isset($_GET["adm"])) ? $_GET["adm"] : 0;
					if ( deleteACLmanagement ( $vo, $uid, $admid, $pvap, $USER_DN, $USER_CA, $member ) == -1 )
						hackexit(1);
					echo "</div>";
			    	} else hackexit(1);
				echo "<div class=\"mt20\"></div>\n";
				echo "</div>\n"; // workarea div
			// ###action: register -- proceed with user registration request
			} else if ( $action === "register" ) {
				require("vo_action_register.php");
			// ###action: confirmation -- register user confirmation
			} else if ( $action === "confirmation" ) {
				require("vo_action_confirmation.php");
			// ###action: subscriptions -- process mwmbership requests
			} else if ( $action === "subscriptions" ) {
				require("vo_action_subscriptions.php");
			// ###action: configuration -- print configuration instructions
			} else if ( $action === "configuration" ) {
				require("vo_action_configuration.php");
			// ###action: preferences -- VO related preferences (site, rules, etc.)	##PVA extension
			} else if ( $action === "preferences") {
				// Left preferences menu allways present
				require("vo_action_preferences_menu.php");
				// workarea is container to direct information specified by $operation
				echo "<div id=\"workarea\">\n";
				if ( $operation === "replicate" ) {
					require("vo_action_preferences_op_replicate.php");
				} else if ( $operation === "transactions" ) {
					require("vo_action_preferences_op_transactions.php");
				} else if ( $operation === "eventlog" ) {
					require("vo_action_preferences_op_eventlog.php");
				} else {
					// default operation: change display properties
					require("vo_action_preferences_op_display.php");
				}
				echo "</div>\n"; 
			}
		}		
	echo "</div>\n"; 
	echo "<div style=\"clear: both;\"></div>\n";
	echo "<div id=\"footer\">\n";
	printf($voms_footer_caption,$pva_version);
	echo "</div>\n";
echo "</div>\n"; 
echo "</div>\n";

echo "</body>\n";
echo "</html>\n";
?>
